import { create } from '@storybook/theming';

import './styles.css';

export default create({
  base: 'light',

  colorPrimary: '#173845',
  colorSecondary: '#32819f',

  // UI
  appBg: '#ededed',
  appContentBg: '#fff',
  appBorderColor: '#6a6c71',
  appBorderRadius: 0,

  // Typography
  fontBase: '"Arial", sans-serif',
  fontCode: 'monospace',

  // Text colors
  textColor: '#173845',
  textInverseColor: 'rgba(255,255,255,0.9)',

  // Toolbar default and active colors
  barTextColor: '#fff',
  barSelectedColor: '#fff',
  barBg: '#25586d',

  // Form colors
  inputBg: 'white',
  inputBorder: 'silver',
  inputTextColor: 'black',
  inputBorderRadius: 4,

  brandTitle: 'JMAN Group',
  brandUrl: 'https://example.com',
  brandImage: 'https://www.jmangroup.com/wp-content/uploads/2018/11/jman_black_strip-1024x229.png',
});