var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import React from 'react';
import { Collapse, NavLink as BsNavLink } from 'reactstrap';
import { NavLink } from 'react-router-dom';
var SideBar = /** @class */ (function (_super) {
    __extends(SideBar, _super);
    function SideBar(props) {
        var _this = _super.call(this, props) || this;
        _this.toggle = _this.toggle.bind(_this);
        _this.state = { activeSubMenu: undefined };
        return _this;
    }
    SideBar.prototype.toggle = function (e) {
        if (this.state.activeSubMenu === e) {
            this.setState({
                activeSubMenu: undefined,
            });
        }
        else {
            this.setState({
                activeSubMenu: e,
            });
        }
    };
    SideBar.prototype.render = function () {
        var _this = this;
        return (React.createElement("nav", { className: "sidebar" },
            React.createElement("div", null,
                React.createElement("a", { className: "logo text-center" }, "Logo"),
                React.createElement("ul", { className: "sidebar-nav" }, this.props.sideBarRoutes.map(function (v, k) {
                    if (v.submenus) {
                        return (React.createElement("li", { className: "sidebar-nav-item", key: k },
                            React.createElement(BsNavLink, { className: "sidebar-nav-link", onClick: function () { return _this.toggle(v.index); } },
                                React.createElement("i", { className: "nav-link-icon mdi " + v.icon }),
                                React.createElement("span", { className: "va-sub" }, v.label),
                                _this.state.activeSubMenu === v.index ? (React.createElement("i", { className: "mdi mdi-chevron-down" })) : (React.createElement("i", { className: "mdi mdi-chevron-right" }))),
                            React.createElement(Collapse, { isOpen: _this.state.activeSubMenu === v.index },
                                React.createElement("ul", { className: "sidebar-nav-submenu" }, v.submenus.map(function (v1, k1) {
                                    return (React.createElement("li", { key: k1, className: "sidebar-nav-item" },
                                        React.createElement(NavLink, { to: v1.path, className: "sidebar-nav-link" },
                                            React.createElement("span", { className: "va-sub" }, v1.label))));
                                })))));
                    }
                    else {
                        return (React.createElement("li", { className: "sidebar-nav-item", key: k },
                            React.createElement(NavLink, { to: v.path, className: "sidebar-nav-link", onClick: function () { return _this.toggle(v.index); } },
                                React.createElement("i", { className: "nav-link-icon mdi " + v.icon }),
                                React.createElement("span", { className: "va-sub" }, v.label))));
                    }
                })))));
    };
    return SideBar;
}(React.PureComponent));
export default SideBar;
//# sourceMappingURL=SideBar.js.map