var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import { Modal, ModalHeader, ModalBody } from 'reactstrap';
import BootstrapTable from 'react-bootstrap-table-next';
import paginationFactory from 'react-bootstrap-table2-paginator';
import ToolkitProvider, { Search, ColumnToggle, } from 'react-bootstrap-table2-toolkit';
import { FaCog } from 'react-icons/fa';
import _ from 'lodash';
import ActionButton from './ActionButton';
import { ContextMenu, MenuItem, ContextMenuTrigger } from 'react-contextmenu';
import Hotkeys from 'react-hot-keys';
import { FaPlus, FaPencilAlt, FaTimes } from 'react-icons/fa';
var CustomToggleList = ColumnToggle.CustomToggleList;
var SearchBar = Search.SearchBar;
var rows = [];
var BootstrapTableNext = /** @class */ (function (_super) {
    __extends(BootstrapTableNext, _super);
    function BootstrapTableNext(props) {
        var _this = _super.call(this, props) || this;
        _this.sendData = function (row, isSelect, rowIndex, _e) {
            _this.props.getData
                ? _this.props.getData(row, isSelect, rowIndex, _this.props.columns)
                : console.log('Function is missing');
        };
        _this.rowEvents = {
            onContextMenu: function (e, row, rowIndex) {
                _this.props.getData
                    ? _this.props.getData(row, '0', rowIndex, _this.props.columns)
                    : console.log('Function is missing');
                e.preventDefault();
            },
            onMouseLeave: function () {
                _this.setState({ hoverIdx: null });
            },
        };
        _this.toggle = _this.toggle.bind(_this);
        _this.state = {
            modal: false,
            toggle: false,
            myColumns: {
                key: _this.props.keyField,
                column: _.map(_this.props.columns, 'dataField'),
            },
            editModal: false,
            editToggle: false,
            rows: rows,
        };
        return _this;
    }
    BootstrapTableNext.prototype.toggle = function () {
        this.setState({
            toggle: !this.state.toggle,
            modal: !this.state.modal,
        });
    };
    BootstrapTableNext.prototype.onColumnToggle = function (data) {
        var _a;
        var myCookieVal = (_a = {},
            _a[this.props.name] = this.props.name,
            _a.value = [],
            _a);
        if (data.toggle) {
            _.remove(this.state.myColumns.column, function (el) {
                // remove column
                return el === data.dataField;
            });
            myCookieVal.value = this.state.myColumns.column;
            //setCookie(getCookie('username'), this.props.name, [myCookieVal]);
        }
        else {
            this.state.myColumns.column.push(data.dataField);
            myCookieVal.value = this.state.myColumns.column;
            //setCookie(getCookie('username'), this.props.name, [myCookieVal]);
        }
    };
    BootstrapTableNext.prototype.handleClick = function (row, _isSelect, _rowIndex, columns) {
        var rows = [];
        rows.push(row);
        this.setState({ rows: rows, columns: columns });
    };
    BootstrapTableNext.prototype.onKeyUp = function (_keyName, _e, handle) {
        if (handle.shortcut === 'alt+s') {
            this.toggle();
        }
    };
    BootstrapTableNext.prototype.onKeyDown = function (_keyName, _e, _handle) { };
    BootstrapTableNext.prototype.render = function () {
        var _this = this;
        var options = {
            showTotal: true,
        };
        var selectRow = {
            mode: 'checkbox',
            clickToSelect: true,
            onSelect: this.sendData,
        };
        return (React.createElement("div", null,
            React.createElement(ToolkitProvider, { keyField: this.props.keyField ? this.props.keyField : 'id', data: this.props.data, columns: this.props.columns, search: true, columnToggle: true }, function (props) { return (React.createElement("div", null,
                React.createElement("div", { className: "row" },
                    React.createElement("div", { className: "col-md-3" },
                        React.createElement(SearchBar, __assign({ className: "input-style" }, props.searchProps))),
                    React.createElement("div", { className: "col-md-8 action-buttons-bottom" }, _this.props.actionButtons ? (React.createElement(ActionButton, { btnClass: "", actionBtn: _this.props.actionButtons, showHotKey: _this.props.showHotKey, createBtnOnClick: _this.props.createBtnOnClick, editBtnOnClick: _this.props.editBtnOnClick, deleteBtnOnClick: _this.props.deleteBtnOnClick })) : ('')),
                    React.createElement("div", { className: "col-md-1 d-flex justify-content-end" },
                        React.createElement("div", { className: "hot-key-settings" }, _this.props.showHotKey ? (React.createElement("text", { className: "hot-key" }, "S")) : null),
                        React.createElement(FaCog, { onClick: _this.toggle }))),
                React.createElement(ContextMenuTrigger, { id: "some_unique_identifier" },
                    React.createElement(BootstrapTable, __assign({}, props.baseProps, { keyField: _this.props.keyField ? _this.props.keyField : 'id', data: _this.props.data, columns: _this.props.columns, striped: true, hover: true, condensed: true, bootstrap4: true, pagination: paginationFactory(options), selectRow: selectRow, noDataIndication: "No Data to Show", wrapperClasses: "table-responsive", bordered: _this.props.bordered, filterPosition: "top", rowEvents: _this.rowEvents }))),
                React.createElement(ContextMenu, { id: "some_unique_identifier" },
                    React.createElement(MenuItem, { data: { foo: 'bar' }, onClick: _this.props.createBtnOnClick },
                        React.createElement(FaPlus, null),
                        " ",
                        React.createElement("u", null, "C"),
                        "reate"),
                    React.createElement(MenuItem, { data: { foo: 'bar' }, onClick: _this.props.editBtnOnClick },
                        React.createElement(FaPencilAlt, null),
                        " ",
                        React.createElement("u", null, "E"),
                        "dit"),
                    React.createElement(MenuItem, { divider: true }),
                    React.createElement(MenuItem, { data: { foo: 'bar' }, onClick: _this.props.deleteBtnOnClick },
                        React.createElement(FaTimes, null),
                        " ",
                        React.createElement("u", null, "D"),
                        "elete")),
                React.createElement(Hotkeys, { keyName: "alt+s", onKeyDown: _this.onKeyDown.bind(_this), onKeyUp: _this.onKeyUp.bind(_this) },
                    React.createElement(Modal, { isOpen: _this.state.modal, toggle: _this.toggle, size: "xl" },
                        React.createElement(ModalHeader, { toggle: _this.toggle }, "Column Settings"),
                        React.createElement(ModalBody, { className: "toggle-col" },
                            React.createElement(CustomToggleList, __assign({}, props.columnToggleProps))))))); })));
    };
    BootstrapTableNext.defaultProps = {
        key: 'account_id',
        checkAll: false,
        pagination: true,
        selectAll: {
            mode: 'checkbox',
            clickToSelect: true,
        },
        bordered: false,
    };
    return BootstrapTableNext;
}(React.PureComponent));
export default BootstrapTableNext;
//# sourceMappingURL=BootstrapTableNext.js.map