var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import React from 'react';
import { Popover } from 'reactstrap';
import { NavLink } from 'react-router-dom';
var SideBarXs = /** @class */ (function (_super) {
    __extends(SideBarXs, _super);
    function SideBarXs(props) {
        var _this = _super.call(this, props) || this;
        _this.toggle = _this.toggle.bind(_this);
        _this.state = { activeSubMenu: undefined };
        return _this;
    }
    SideBarXs.prototype.toggle = function (e) {
        console.log(e);
        if (this.state.activeSubMenu === e) {
            this.setState({
                activeSubMenu: undefined,
            });
        }
        else {
            this.setState({
                activeSubMenu: e,
            });
        }
    };
    SideBarXs.prototype.render = function () {
        var _this = this;
        return (React.createElement("nav", { className: "sidebar-sm" },
            React.createElement("div", null,
                React.createElement("a", { className: "logo text-center" }, "Logo"),
                React.createElement("ul", { className: "sidebar-nav" }, this.props.sideBarRoutes.map(function (v, k) {
                    if (v.submenus) {
                        return (React.createElement("li", { className: "sidebar-nav-item", key: k },
                            React.createElement(NavLink, { to: v.path, className: "sidebar-nav-link", id: "sidebar-" + v.index, onClick: function () { return _this.toggle(v.index); } },
                                React.createElement("i", { className: "mdi " + v.icon })),
                            React.createElement(Popover, { placement: "right-start", hideArrow: true, isOpen: _this.state.activeSubMenu === v.index, target: "sidebar-" + v.index, trigger: "hover" },
                                React.createElement("ul", { className: "sidebar-nav-submenu" }, v.submenus.map(function (v1, k1) {
                                    return (React.createElement("li", { key: k1, className: "sidebar-nav-item" },
                                        React.createElement(NavLink, { to: v1.path, className: "sidebar-nav-link" }, v1.label)));
                                })))));
                    }
                    else {
                        return (React.createElement("li", { className: "sidebar-nav-item", key: k },
                            React.createElement(NavLink, { to: v.path, className: "sidebar-nav-link", onClick: function () { return _this.toggle(v.index); } },
                                React.createElement("i", { className: "mdi " + v.icon }))));
                    }
                })))));
    };
    return SideBarXs;
}(React.PureComponent));
export default SideBarXs;
//# sourceMappingURL=SideBarXS.js.map