var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import React from 'react';
import { Button } from 'reactstrap';
import { FaPlus, FaPencilAlt, FaTimes, FaRegCheckSquare, FaExchangeAlt, FaEllipsisV, FaShareSquare, FaRegFile, } from 'react-icons/fa';
import { MdPriorityHigh } from 'react-icons/md';
import { IoMdPaper } from 'react-icons/io';
var ActionButton = /** @class */ (function (_super) {
    __extends(ActionButton, _super);
    function ActionButton(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {};
        return _this;
    }
    ActionButton.prototype.render = function () {
        return (React.createElement("div", null,
            this.props.actionBtn.isCreate ? (React.createElement(Button, { color: this.props.btnClass, onClick: this.props.createBtnOnClick, className: "action-button" }, this.props.showHotKey ? (React.createElement(React.Fragment, null,
                React.createElement(FaPlus, null),
                " ",
                React.createElement("span", { className: "hot-key" }, "C"),
                "reate")) : (React.createElement(React.Fragment, null,
                React.createElement(FaPlus, null),
                " ",
                React.createElement("u", null, "C"),
                "reate")))) : (''),
            this.props.actionBtn.isEdit ? (React.createElement(Button, { color: this.props.btnClass, onClick: this.props.editBtnOnClick, className: "action-button" }, this.props.showHotKey ? (React.createElement(React.Fragment, null,
                React.createElement(FaPencilAlt, null),
                " ",
                React.createElement("span", { className: "hot-key" }, "E"),
                "dit")) : (React.createElement(React.Fragment, null,
                React.createElement(FaPencilAlt, null),
                " ",
                React.createElement("u", null, "E"),
                "dit")))) : (''),
            this.props.actionBtn.isDelete ? (React.createElement(Button, { color: this.props.btnClass, onClick: this.props.deleteBtnOnClick, className: "action-button" }, this.props.showHotKey ? (React.createElement(React.Fragment, null,
                React.createElement(FaTimes, null),
                " ",
                React.createElement("span", { className: "hot-key" }, "D"),
                "elete")) : (React.createElement(React.Fragment, null,
                React.createElement(FaTimes, null),
                " ",
                React.createElement("u", null, "D"),
                "elete")))) : (''),
            this.props.actionBtn.isProcess ? (React.createElement(Button, { color: this.props.btnClass, className: "action-button" }, this.props.showHotKey ? (React.createElement(React.Fragment, null,
                React.createElement(FaRegCheckSquare, null),
                " ",
                React.createElement("span", { className: "hot-key" }, "P"),
                "rocess")) : (React.createElement(React.Fragment, null,
                React.createElement(FaRegCheckSquare, null),
                " ",
                React.createElement("u", null, "P"),
                "rocess")))) : (''),
            this.props.actionBtn.isAssign ? (React.createElement(Button, { color: this.props.btnClass, className: "action-button" },
                React.createElement(FaExchangeAlt, null),
                " Assign")) : (''),
            this.props.actionBtn.isMarkAs ? (React.createElement(Button, { color: this.props.btnClass, className: "action-button" }, this.props.showHotKey ? (React.createElement(React.Fragment, null,
                React.createElement(FaEllipsisV, null),
                " ",
                React.createElement("span", { className: "hot-key" }, "M"),
                "ark As")) : (React.createElement(React.Fragment, null,
                React.createElement(FaEllipsisV, null),
                " ",
                React.createElement("u", null, "M"),
                "ark As")))) : (''),
            this.props.actionBtn.isExport ? (React.createElement(Button, { color: this.props.btnClass, className: "action-button" }, this.props.showHotKey ? (React.createElement(React.Fragment, null,
                React.createElement(FaShareSquare, null),
                " E",
                React.createElement("span", { className: "hot-key" }, "x"),
                "port")) : (React.createElement(React.Fragment, null,
                React.createElement(FaShareSquare, null),
                " E",
                React.createElement("u", null, "x"),
                "port")))) : (''),
            this.props.actionBtn.isReports ? (React.createElement(Button, { color: this.props.btnClass, className: "action-button" }, this.props.showHotKey ? (React.createElement(React.Fragment, null,
                React.createElement(FaRegFile, null),
                " ",
                React.createElement("span", { className: "hot-key" }, "R"),
                "eports")) : (React.createElement(React.Fragment, null,
                React.createElement(FaRegFile, null),
                " ",
                React.createElement("u", null, "R"),
                "eports")))) : (''),
            this.props.actionBtn.isPriority ? (React.createElement(Button, { color: this.props.btnClass, className: "action-button" }, this.props.showHotKey ? (React.createElement(React.Fragment, null,
                React.createElement(MdPriorityHigh, null),
                " ",
                React.createElement("span", { className: "hot-key" }, "S"),
                "et Priority")) : (React.createElement(React.Fragment, null,
                React.createElement(MdPriorityHigh, null),
                " ",
                React.createElement("u", null, "S"),
                "et Priority")))) : (''),
            this.props.actionBtn.isTemplates ? (React.createElement(Button, { color: this.props.btnClass, className: "action-button" },
                React.createElement(IoMdPaper, null),
                " Templates")) : ('')));
    };
    return ActionButton;
}(React.Component));
export default ActionButton;
//# sourceMappingURL=ActionButton.js.map