import React from 'react';
interface Props {
    key?: string;
    name: string;
    keyField: string;
    checkAll?: true | false;
    pagination?: true | false;
    data: Array<any>;
    columns: Array<any>;
    selectAll: {
        mode: string;
        clickToSelect?: boolean;
        onSelect?: Function;
    };
    actionButtons?: any;
    bordered?: true | false;
    showHotKey?: boolean;
    getData?: Function;
    createBtnOnClick?: () => void;
    editBtnOnClick?: () => void;
    deleteBtnOnClick?: () => void;
}
declare class BootstrapTableNext extends React.PureComponent<Props, any> {
    static defaultProps: {
        key: string;
        checkAll: boolean;
        pagination: boolean;
        selectAll: {
            mode: string;
            clickToSelect: boolean;
        };
        bordered: boolean;
    };
    constructor(props: Props);
    toggle(): void;
    onColumnToggle(data: any): void;
    sendData: (row: any, isSelect: any, rowIndex: any, _e: any) => void;
    handleClick(row: any, _isSelect: any, _rowIndex: any, columns: any): void;
    rowEvents: {
        onContextMenu: (e: any, row: any, rowIndex: any) => void;
        onMouseLeave: () => void;
    };
    onKeyUp(_keyName: any, _e: any, handle: any): void;
    onKeyDown(_keyName: any, _e: any, _handle: any): void;
    render(): JSX.Element;
}
export default BootstrapTableNext;
