var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import React from 'react';
import { Button } from 'reactstrap';
import Hotkeys from 'react-hot-keys';
// import Reorder, { reorder } from 'react-reorder';
import Reorder from 'react-reorder';
var ColumnSettings = /** @class */ (function (_super) {
    __extends(ColumnSettings, _super);
    function ColumnSettings(props) {
        var _this = _super.call(this, props) || this;
        _this.toggle = function () {
            _this.setState({
                toggle: !_this.state.toggle,
                modal: !_this.state.modal,
            });
        };
        _this.onColumnSwitchApply = function () {
            var reOrder = [];
            var dataSet = __spreadArrays(_this.props.data);
            dataSet.forEach(function (item) {
                var obj = {};
                _this.state.column_order.forEach(function (col) {
                    obj[col] = item[col];
                });
                reOrder.push(obj);
            });
            _this.props.sendSettings(reOrder, _this.state.column_order);
            _this.toggle();
        };
        _this.state = {
            toggle: false,
            modal: false,
            list: _this.props.headers,
            column_order: [],
        };
        return _this;
    }
    ColumnSettings.prototype.componentDidMount = function () {
        this.props.onRef(this);
    };
    ColumnSettings.prototype.componentWillUnmount = function () {
        this.props.onRef(null);
    };
    // onReorder(event, previousIndex, nextIndex, fromId, toId) {
    //     this.setState({
    //         list: reorder(this.state.list, previousIndex, nextIndex),
    //     });
    //     var ord = [];
    //     this.state.list.forEach((item) => {
    //         ord.push(item.value);
    //     });
    //     this.setState({
    //         column_order: ord,
    //     });
    // }
    ColumnSettings.prototype.onReorder = function () { };
    ColumnSettings.prototype.onKeyUp = function (handle) {
        if (handle.shortcut === 'alt+s') {
            this.toggle();
        }
    };
    ColumnSettings.prototype.onKeyDown = function () { };
    ColumnSettings.prototype.render = function () {
        return (React.createElement("div", null,
            React.createElement(Hotkeys, { keyName: "alt+s", onKeyDown: this.onKeyDown.bind(this), onKeyUp: this.onKeyUp.bind(this) },
                React.createElement(Reorder, { reorderId: "my-list", reorderGroup: "reorder-group", 
                    //getRef={this.storeRef.bind(this)}
                    component: "p", placeholderClassName: "placeholder", draggedClassName: "dragged", lock: "vertical", holdTime: 200, touchHoldTime: 200, mouseHoldTime: 200, onReorder: this.onReorder.bind(this), autoScroll: true, disabled: false, disableContextMenus: true, placeholder: React.createElement("div", { className: "custom-placeholder", style: {
                            border: '2px dashed #2b4494',
                            width: '100px',
                            paddingTop: '10px',
                            paddingBottom: '10px',
                            backgroundColor: '#8594c1',
                            textAlign: 'center',
                            color: '#fff',
                            opacity: 0.5,
                            display: 'inline-block',
                        } }, "Drop Here") }, this.state.list.map(function (item) { return (React.createElement("div", { key: item.value, style: {
                        border: '1px solid #2b4494',
                        padding: '10px',
                        width: 'auto',
                        marginLeft: '3px',
                        marginRight: '3px',
                        display: 'inline-block',
                        cursor: 'pointer',
                    } }, item.label)); })),
                React.createElement(Button, { className: "submit-button-style", onClick: this.onColumnSwitchApply }, "Apply"))));
    };
    return ColumnSettings;
}(React.PureComponent));
export default ColumnSettings;
//# sourceMappingURL=ColumnSettings.js.map