var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import React from 'react';
import { TabContent, TabPane, Nav, NavItem, NavLink, } from 'reactstrap';
import DynamicForm from './DynamicForm';
// import { generateYupSchema } from 'utils/Form';
import classnames from 'classnames';
import Table from './BootstrapTableNext';
var TabComponent = /** @class */ (function (_super) {
    __extends(TabComponent, _super);
    function TabComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        // intialize the active tab, class
        _this.state = { activeTab: _this.props.field.tabActive, classes: 'col-md-12' };
        return _this;
    }
    // Event Handlers
    TabComponent.prototype.changeHandler = function () {
        // console.log(this.state);
    };
    // OnSubmit function
    TabComponent.prototype.onFormSubmit = function () {
        // console.log(values);
    };
    TabComponent.prototype.componentWillMount = function () {
        // inittialize the active tabs
        this.setState({
            activeTab: this.props.field.tabActive,
            classes: 'col-md-12',
        });
    };
    TabComponent.prototype.render = function () {
        var _this = this;
        // const validateSchema = generateYupSchema(fields);
        // Toggle the Active tab
        var toggle = function (tab) {
            _this.setState({
                activeTab: tab,
            });
        };
        return (React.createElement("div", { className: this.props.field.classNames
                ? this.props.field.classNames
                : this.state.classes, key: this.props.name },
            React.createElement(Nav, { tabs: true }, this.props.field.tabList.map(function (tab) {
                return (React.createElement(NavItem, null,
                    React.createElement(NavLink, { className: classnames({
                            active: _this.state.activeTab === tab.title,
                        }), onClick: function () {
                            toggle(tab.title);
                        } }, tab.title)));
            }, this)),
            React.createElement(TabContent, { activeTab: this.state.activeTab, style: {
                    borderRight: '1px solid #dee2e6',
                    borderLeft: '1px solid #dee2e6',
                    borderBottom: '1px solid #dee2e6',
                } }, this.props.field.tabList.map(function (tab) {
                return (React.createElement(TabPane, { tabId: tab.title, style: { backgroundColor: 'red !important' } }, typeof tab.tabcontent !== 'string' ? (React.createElement("div", null,
                    React.createElement(DynamicForm, { key: "json-form", 
                        // form={form}
                        layout: 'grid', promptIfUnsaved: true, layoutGrid: 4, labelPosition: "right", fields: tab.tabcontent, 
                        // validation={validateSchema}
                        onFormSubmit: _this.onFormSubmit, changeHandler: _this.changeHandler }),
                    tab.hasTable && (React.createElement(Table, { name: tab.tableData.name, keyField: "id", data: tab.tableData.data, columns: tab.tableData.columns, actionButtons: tab.tableData.actionButtons })))) : (React.createElement("div", null,
                    tab.tabcontent,
                    tab.hasTable && (React.createElement(Table, { name: tab.tableData.name, keyField: "id", data: tab.tableData.data, columns: tab.tableData.columns, actionButtons: tab.tableData.actionButtons }))))));
            }))));
    };
    return TabComponent;
}(React.Component));
export default TabComponent;
//# sourceMappingURL=Tab.js.map