import React from 'react';
import 'react-virtualized/styles.css';
interface Props {
    data: Array<any>;
    headers: Array<any>;
    form?: any;
    showHotKey?: boolean;
    isEdit?: boolean;
    isDelete?: boolean;
    showContextMenu?: boolean;
    actionButtons?: any;
    bordered?: true | false;
    onScroll?: Function;
    onEdit?: Function;
    onDelete?: Function;
    getData?: Function;
    getRow?: Function;
    updateTable?: Function;
    contextMenuEditModal?: Function;
}
interface State {
    data: Array<any>;
    headers: Array<any>;
    rowData: any;
    sortDirection: any;
    sortedColumn: string;
    row: any;
    column: any;
    editedValue: string;
    rowIndex: any;
    sorted: boolean;
}
export default class VirtualizedTable extends React.PureComponent<Props, State, any> {
    constructor(props: Props);
    componentDidUpdate(): void;
    transform: (row: any, column: any) => void;
    cancel: () => void;
    edit: (column_index: any, index: any) => void;
    handleEdit: (event: any) => void;
    sort: (sortBy: any) => void;
    getRowData: (props: any) => void;
    renderTable: (values: any) => void;
    renderRow: (props: any) => JSX.Element;
    renderHeader: (props: any) => JSX.Element;
    noScroll: () => void;
    render(): JSX.Element;
}
export {};
